<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: IFunction Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li><a href="classes.xhtml"><span>Data&#160;Structure&#160;Index</span></a></li>
      <li><a href="inherits.xhtml"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.xhtml"><span>Data&#160;Fields</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('classarm__compute_1_1_i_function.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a>  </div>
  <div class="headertitle">
<div class="title">IFunction Class Reference<span class="mlabels"><span class="mlabel">abstract</span></span></div>  </div>
</div><!--header-->
<div class="contents">

<p>Base class for all functions.  
 <a href="classarm__compute_1_1_i_function.xhtml#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="_i_function_8h_source.xhtml">IFunction.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a18954417d3124a8095783ea13dc6d00b"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_function.xhtml#a18954417d3124a8095783ea13dc6d00b">run</a> ()=0</td></tr>
<tr class="memdesc:a18954417d3124a8095783ea13dc6d00b"><td class="mdescLeft">&#160;</td><td class="mdescRight">Run the kernels contained in the function.  <a href="#a18954417d3124a8095783ea13dc6d00b">More...</a><br /></td></tr>
<tr class="separator:a18954417d3124a8095783ea13dc6d00b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab921ecc3f3f6ae2b4bd61f3e1998d8c4"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classarm__compute_1_1_i_function.xhtml#ab921ecc3f3f6ae2b4bd61f3e1998d8c4">~IFunction</a> ()=default</td></tr>
<tr class="memdesc:ab921ecc3f3f6ae2b4bd61f3e1998d8c4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor.  <a href="#ab921ecc3f3f6ae2b4bd61f3e1998d8c4">More...</a><br /></td></tr>
<tr class="separator:ab921ecc3f3f6ae2b4bd61f3e1998d8c4"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Base class for all functions. </p>

<p>Definition at line <a class="el" href="_i_function_8h_source.xhtml#l00030">30</a> of file <a class="el" href="_i_function_8h_source.xhtml">IFunction.h</a>.</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab921ecc3f3f6ae2b4bd61f3e1998d8c4"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual ~<a class="el" href="classarm__compute_1_1_i_function.xhtml">IFunction</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span><span class="mlabel">default</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="a18954417d3124a8095783ea13dc6d00b"></a>
<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual void run </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">pure virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Run the kernels contained in the function. </p>
<p>For NEON kernels:</p><ul>
<li>Multi-threading is used for the kernels which are parallelisable.</li>
<li>By default std::thread::hardware_concurrency() threads are used.</li>
</ul>
<dl class="section note"><dt>Note</dt><dd><a class="el" href="classarm__compute_1_1_c_p_p_scheduler.xhtml#ae9dc1846ff1612778bbac85d46344aef">CPPScheduler::force_number_of_threads()</a> can be used to manually set the number of threads</dd></dl>
<p>For OpenCL kernels:</p><ul>
<li>All the kernels are enqueued on the queue associated with <a class="el" href="classarm__compute_1_1_c_l_scheduler.xhtml" title="Provides global access to a CL context and command queue. ">CLScheduler</a>.</li>
<li>The queue is then flushed.</li>
</ul>
<dl class="section note"><dt>Note</dt><dd>The function will not block until the kernels are executed. It is the user's responsibility to wait. </dd></dl>

<p>Implemented in <a class="el" href="classarm__compute_1_1_n_e_convolution9x9.xhtml#ad1717410afd0be936c6213a63c8005fb">NEConvolution9x9</a>, <a class="el" href="classarm__compute_1_1_n_e_convolution7x7.xhtml#ad1717410afd0be936c6213a63c8005fb">NEConvolution7x7</a>, <a class="el" href="classarm__compute_1_1_n_e_gaussian_pyramid_orb.xhtml#ad1717410afd0be936c6213a63c8005fb">NEGaussianPyramidOrb</a>, <a class="el" href="classarm__compute_1_1_c_l_gaussian_pyramid_orb.xhtml#ad1717410afd0be936c6213a63c8005fb">CLGaussianPyramidOrb</a>, <a class="el" href="classarm__compute_1_1_c_l_optical_flow.xhtml#ad1717410afd0be936c6213a63c8005fb">CLOpticalFlow</a>, <a class="el" href="classarm__compute_1_1_n_e_gaussian_pyramid_half.xhtml#ad1717410afd0be936c6213a63c8005fb">NEGaussianPyramidHalf</a>, <a class="el" href="classarm__compute_1_1_c_l_gaussian_pyramid_half.xhtml#ad1717410afd0be936c6213a63c8005fb">CLGaussianPyramidHalf</a>, <a class="el" href="classarm__compute_1_1_c_l_convolution_square.xhtml#ad1717410afd0be936c6213a63c8005fb">CLConvolutionSquare&lt; matrix_size &gt;</a>, <a class="el" href="classarm__compute_1_1_c_l_harris_corners.xhtml#ad1717410afd0be936c6213a63c8005fb">CLHarrisCorners</a>, <a class="el" href="classarm__compute_1_1_n_e_convolution5x5.xhtml#ad1717410afd0be936c6213a63c8005fb">NEConvolution5x5</a>, <a class="el" href="classarm__compute_1_1_n_e_harris_corners.xhtml#ad1717410afd0be936c6213a63c8005fb">NEHarrisCorners</a>, <a class="el" href="classarm__compute_1_1_n_e_h_o_g_multi_detection.xhtml#ad1717410afd0be936c6213a63c8005fb">NEHOGMultiDetection</a>, <a class="el" href="classarm__compute_1_1_c_l_laplacian_reconstruct.xhtml#ad1717410afd0be936c6213a63c8005fb">CLLaplacianReconstruct</a>, <a class="el" href="classarm__compute_1_1_n_e_laplacian_reconstruct.xhtml#ad1717410afd0be936c6213a63c8005fb">NELaplacianReconstruct</a>, <a class="el" href="classarm__compute_1_1_n_e_canny_edge.xhtml#ad1717410afd0be936c6213a63c8005fb">NECannyEdge</a>, <a class="el" href="classarm__compute_1_1_n_e_optical_flow.xhtml#ad1717410afd0be936c6213a63c8005fb">NEOpticalFlow</a>, <a class="el" href="classarm__compute_1_1_c_l_g_e_m_m_lowp.xhtml#ad1717410afd0be936c6213a63c8005fb">CLGEMMLowp</a>, <a class="el" href="classarm__compute_1_1_n_e_g_e_m_m_lowp.xhtml#ad1717410afd0be936c6213a63c8005fb">NEGEMMLowp</a>, <a class="el" href="classarm__compute_1_1_c_l_convolution_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">CLConvolutionLayer</a>, <a class="el" href="classarm__compute_1_1_c_l_laplacian_pyramid.xhtml#ad1717410afd0be936c6213a63c8005fb">CLLaplacianPyramid</a>, <a class="el" href="classarm__compute_1_1_n_e_laplacian_pyramid.xhtml#ad1717410afd0be936c6213a63c8005fb">NELaplacianPyramid</a>, <a class="el" href="classarm__compute_1_1_c_l_fast_corners.xhtml#ad1717410afd0be936c6213a63c8005fb">CLFastCorners</a>, <a class="el" href="classarm__compute_1_1_c_l_min_max_location.xhtml#ad1717410afd0be936c6213a63c8005fb">CLMinMaxLocation</a>, <a class="el" href="classarm__compute_1_1_c_l_g_e_m_m.xhtml#ad1717410afd0be936c6213a63c8005fb">CLGEMM</a>, <a class="el" href="classarm__compute_1_1_n_e_convolution_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">NEConvolutionLayer</a>, <a class="el" href="classarm__compute_1_1_c_l_canny_edge.xhtml#a108972ffc2f5536ceee15428b2b130ad">CLCannyEdge</a>, <a class="el" href="classarm__compute_1_1_n_e_fast_corners.xhtml#ad1717410afd0be936c6213a63c8005fb">NEFastCorners</a>, <a class="el" href="classarm__compute_1_1_c_l_fully_connected_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">CLFullyConnectedLayer</a>, <a class="el" href="classarm__compute_1_1_n_e_fully_connected_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">NEFullyConnectedLayer</a>, <a class="el" href="classarm__compute_1_1_n_e_g_e_m_m.xhtml#ad1717410afd0be936c6213a63c8005fb">NEGEMM</a>, <a class="el" href="classarm__compute_1_1_n_e_sobel5x5.xhtml#ad1717410afd0be936c6213a63c8005fb">NESobel5x5</a>, <a class="el" href="classarm__compute_1_1_n_e_sobel7x7.xhtml#ad1717410afd0be936c6213a63c8005fb">NESobel7x7</a>, <a class="el" href="classarm__compute_1_1_c_l_sobel5x5.xhtml#ad1717410afd0be936c6213a63c8005fb">CLSobel5x5</a>, <a class="el" href="classarm__compute_1_1_c_l_sobel7x7.xhtml#ad1717410afd0be936c6213a63c8005fb">CLSobel7x7</a>, <a class="el" href="classarm__compute_1_1_n_e_min_max_location.xhtml#ad1717410afd0be936c6213a63c8005fb">NEMinMaxLocation</a>, <a class="el" href="classarm__compute_1_1_n_e_derivative.xhtml#ad1717410afd0be936c6213a63c8005fb">NEDerivative</a>, <a class="el" href="classarm__compute_1_1_n_e_equalize_histogram.xhtml#ad1717410afd0be936c6213a63c8005fb">NEEqualizeHistogram</a>, <a class="el" href="classarm__compute_1_1_n_e_h_o_g_gradient.xhtml#ad1717410afd0be936c6213a63c8005fb">NEHOGGradient</a>, <a class="el" href="classarm__compute_1_1_c_l_normalization_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">CLNormalizationLayer</a>, <a class="el" href="classarm__compute_1_1_n_e_gaussian5x5.xhtml#ad1717410afd0be936c6213a63c8005fb">NEGaussian5x5</a>, <a class="el" href="classarm__compute_1_1_n_e_normalization_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">NENormalizationLayer</a>, <a class="el" href="classarm__compute_1_1_c_l_gaussian5x5.xhtml#ad1717410afd0be936c6213a63c8005fb">CLGaussian5x5</a>, <a class="el" href="classarm__compute_1_1_c_l_histogram.xhtml#ad1717410afd0be936c6213a63c8005fb">CLHistogram</a>, <a class="el" href="classarm__compute_1_1_c_l_equalize_histogram.xhtml#ad1717410afd0be936c6213a63c8005fb">CLEqualizeHistogram</a>, <a class="el" href="classarm__compute_1_1_n_e_histogram.xhtml#ad1717410afd0be936c6213a63c8005fb">NEHistogram</a>, <a class="el" href="classarm__compute_1_1_n_e_h_o_g_descriptor.xhtml#ad1717410afd0be936c6213a63c8005fb">NEHOGDescriptor</a>, <a class="el" href="classarm__compute_1_1_n_e_softmax_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">NESoftmaxLayer</a>, <a class="el" href="classarm__compute_1_1_c_l_softmax_layer.xhtml#ad1717410afd0be936c6213a63c8005fb">CLSoftmaxLayer</a>, <a class="el" href="classarm__compute_1_1_n_e_mean_std_dev.xhtml#ad1717410afd0be936c6213a63c8005fb">NEMeanStdDev</a>, <a class="el" href="classarm__compute_1_1_c_l_integral_image.xhtml#ad1717410afd0be936c6213a63c8005fb">CLIntegralImage</a>, <a class="el" href="classarm__compute_1_1_n_e_fill_border.xhtml#ad1717410afd0be936c6213a63c8005fb">NEFillBorder</a>, <a class="el" href="classarm__compute_1_1_c_l_mean_std_dev.xhtml#ad1717410afd0be936c6213a63c8005fb">CLMeanStdDev</a>, <a class="el" href="classarm__compute_1_1_i_c_l_simple_function.xhtml#ab5fd6e96c07aaaed2747c7e16ed5951e">ICLSimpleFunction</a>, and <a class="el" href="classarm__compute_1_1_i_n_e_simple_function.xhtml#ab5fd6e96c07aaaed2747c7e16ed5951e">INESimpleFunction</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>arm_compute/runtime/<a class="el" href="_i_function_8h_source.xhtml">IFunction.h</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="namespacearm__compute.xhtml">arm_compute</a></li><li class="navelem"><a class="el" href="classarm__compute_1_1_i_function.xhtml">IFunction</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:10 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
